{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE QuasiQuotes #-}

module Main where

import NeatInterpolation (text)
import Network.HTTP.Client (newManager)
import Network.HTTP.Client.TLS (tlsManagerSettings)
import Servant.Client

import HAL (getMetadataWith)
import HAL.Client
import HAL.Doc
import HAL
import Tree
import qualified Data.Text as T


yearReq = [text|
(language_t:en) 
AND (producedDateY_i:2015 
     OR producedDateY_i:2016 
     OR producedDateY_i:2017 
     OR producedDateY_i:2018 
     OR producedDateY_i:2021
     OR producedDateY_i:2022) 
AND (structId_i:302102
    OR structId_i:469216
    OR structId_i:6279
    OR structId_i:224096
    OR structId_i:144103
    OR structId_i:497330
    OR structId_i:1076752
    OR structId_i:84538
    OR structId_i:301262
    OR structId_i:481355
    OR structId_i:29212
    OR structId_i:301442
    OR structId_i:542824
    OR structId_i:300362
    OR structId_i:1048346
    OR structId_i:352124)|]

imt :: [T.Text]
imt = [
  "224096"
  ,"144103"
  ,"84538"
  ,"300104"
  ,"300362"
  ,"301262"
  ,"301442"
  ,"301492"
  ,"302102"
  ,"421532"
  ,"497330"
  ,"352124"
  ,"481355"
  ,"469216"
  ,"542824"
  ,"6279"
  ,"29212"
  ]

main :: IO ()
main = do
  res <- getMetadataWith (generateRequestByStructID "artificial intelligence" imt) (Just 0) (Just 55)
  case res of
    (Left  err) -> print err
    (Right val) -> print $ _docs val
